#line 1 "C:/PIC/MikroC/PIC18/PIC18Q/PIC18F47Q10/Mon7a/Mon7a/main.c"
#line 78 "C:/PIC/MikroC/PIC18/PIC18Q/PIC18F47Q10/Mon7a/Mon7a/main.c"
sbit Chip_Select at LATD0_bit;
sbit Chip_Select_Direction at TRISD0_bit;


void linein(char* pstring);
char getparams(char* tempstring);
void PrintHex(unsigned char ihex);
void PrintHexSp(unsigned char ihex);
void PrintHexInt(unsigned int ihex);
void cmd7(void);
void cmda(void);
void cmdd(void);
void cmdf(void);
void cmdl(void);
void cmdr(void);
void cmdt(void);
void cmdw(void);
void cmdz(void);
void I2C1_Init(unsigned long clock);
unsigned short I2C1_Start(void);
void I2C1_Repeated_Start(void);
void I2C1_Stop(void);
unsigned short I2C1_Wr(unsigned short data_);
unsigned char I2C1_Rd(unsigned char ackflag);
void i2cEEPROM_WrSingle(unsigned int wAddr, unsigned char wData);
unsigned char i2cEEPROM_RdSingle(unsigned int rAddr);
void LCD_Data4(unsigned char lcd_d);
void LCD_Cmd4(char lcmd);
void LCD_Init(void);
void LCD_clear(void);
void LCD_Pos(unsigned char row, unsigned char col);
void LCD_Write(unsigned char lcd_byte);
void LCD_Text(char *ltxt);
void LCD_Cmd(unsigned char lcmd);
void SPI2_Init(void);
void max7219_init(void);
void set_luminosity(unsigned char value);
void display_column(unsigned char col, unsigned char col_num);


unsigned long count10ms;
unsigned char newcmd;
char cmd;
char linebuff[257];
unsigned char param[8][20];
unsigned int upar[8];
unsigned char nparams;
unsigned char EC_hdr;
unsigned char EC_tmp;
unsigned int EC_adr;
unsigned char EC_data;
unsigned int ee_addr;
char ascii_string[18];
char sec, min1, hr, week_day, day, mn, year;
char *txt, tnum[4];
unsigned char t_sec;
unsigned char t_min;
char i;
unsigned char lum;
unsigned char retval1;
unsigned char retval2;
unsigned char retval3;
unsigned char seg[9]={0x37, 0x06, 0x00, 0x37, 0x4f, 0x0e, 0x0e, 0x7e, 0x00};





void Interrupt_Init()
{

    T0CON0 = 0x80;
    T0CON1 = 0x4a;
    TMR0H = 0x9b;
    TMR0L = 0x00;
    TMR0IE_bit = 1;

    INTCON = 0xc0;
}

void interrupt ()
{
    if(TMR0IE && TMR0IF){
        count10ms ++;
        LATA0_bit = ~LATA0_bit;
        TMR0IF_bit = 0;
    }
}


unsigned char SPI_Write(unsigned char spi_byte){

    SSP2BUF = spi_byte;
    while(!BF2_bit);
    return SSP2BUF;
}


void LCD_Clear(void){
	LCD_Cmd(1);
}


void LCD_Pos(unsigned char row, unsigned char col){
  unsigned char offset;

	offset = 0x7f + col;
	if(row == 2){
		offset += 0x40;
	}
	if(row == 3){
		offset += 0x14;
	}
	if(row == 4){
		offset += 0x54;
	}
    LCD_Cmd(offset);
}


void LCD_Data4(unsigned char lcd_d){
    LATB0_bit = lcd_d;
    LATB1_bit = lcd_d >> 1;
    LATB2_bit = lcd_d >> 2;
    LATB3_bit = lcd_d >> 3;
}


void LCD_Cmd4(char lcmd){
	LATB4_bit  = 0;
	LCD_Data4(lcmd);
	LATB5_bit   = 1;
    Delay_ms(4);
    LATB5_bit   = 0;
}


void LCD_Cmd(unsigned char lcmd){
	LATB4_bit  = 0;
	LCD_Data4(lcmd >> 4);
	LATB5_bit   = 1;
    Delay_ms(4);
    LATB5_bit   = 0;
    Delay_ms(4);
	LCD_Data4(lcmd);
	LATB5_bit   = 1;
    Delay_ms(4);
    LATB5_bit   = 0;
}


void LCD_Write(unsigned char lcd_byte){

    LATB4_bit  = 1;
    LCD_Data4((lcd_byte & 0xF0) >> 4);
	LATB5_bit   = 1;
    Delay_us(40);
    LATB5_bit   = 0;
    LCD_Data4(lcd_byte & 0x0F);
	LATB5_bit   = 1;
    Delay_us(40);
    LATB5_bit   = 0;
}


void LCD_Text(char *ltxt){
  int i;

	for(i = 0; ltxt[i] != 0; i++)
	   LCD_Write(ltxt[i]);
}


void LCD_Init(){
    TRISB5_bit = 0;
    TRISC2_bit = 0;
    LATC2_bit = 0;
    TRISB &= 0xe0;

    LCD_Data4(0x00);
    Delay_ms(100);
    LCD_Cmd4(0x03);
	Delay_ms(5);
    LCD_Cmd4(0x03);
	Delay_ms(11);
    LCD_Cmd(0x32);
    LCD_Cmd(0x28);
    LCD_Cmd(0x0C);
    LCD_Cmd(0x06);
    LCD_Clear();
    LCD_Pos(1,1);
}



void PPS_Init(void){

    RC6PPS = 0x09;
    RX1PPS = 0x17;
    RB6PPS = 0x0b;
    RX2PPS = 0x0f;
    RX2PPS = 0x0f;
    RC3PPS = 0x0f;
    RC4PPS = 0x10;

    RD3PPS = 0x11;
    SSP2CLKPPS = 0x1b;
    SSP2DATPPS = 0x1a;
    RD5PPS = 0x12;
}


void SPI2_Init(void){
    SSP2STAT = 0x40;
    SSP2CON1 = 0x22;
    SSP2CON3 = 0;
    SSP2ADD = 200;
    Chip_Select = 1;
    Chip_Select_Direction = 0;
}


void IO_Init(void){

    SLRCONA = 0;
    SLRCONB = 0;
    SLRCONC = 0;
    SLRCOND = 0;
    SLRCONE = 0;
    LATA = 0;
    LATB = 0;
    LATC = 0;
    LATD = 0;
    LATE = 0;
    ANSELA = 0;
    ANSELB = 0;
    ANSELC = 0;
    ANSELD = 0;
    ANSELE = 0;
    TRISA = 0;
    TRISB = 0x80;
    TRISC = 0x98;
    TRISD = 0x04;
    TRISE = 0;
}


void UART_Init(void){

    RC1STA = 0x90;
    TX1STA = 0x20;
    BAUD1CON = 0x08;
    SP1BRG = 0x0022;

    RC2STA = 0x90;
    TX2STA = 0x20;
    BAUD2CON = 0x08;
    SP2BRG = 0x00cf;
    Delay_ms(100);
}


unsigned char chin(void){

    while( ! RCIF_bit);
    return RC1REG;
}


void putch(unsigned char uout_char){

    while( ! TXIF_bit);
    TX1REG = uout_char;
}


void printf(char *ltxt){
  int i;

	for(i = 0; ltxt[i] != 0; i++)
	   putch(ltxt[i]);
}


void Read_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year) {

    I2C1_Start();
    I2C1_Wr(0xD0);
    I2C1_Wr(0);
    I2C1_Repeated_Start();
    I2C1_Wr(0xD1);
    *sec = I2C1_Rd(1);
    *min = I2C1_Rd(1);
    *hr = I2C1_Rd(1);
    *week_day = I2C1_Rd(1);
    *day = I2C1_Rd(1);
    *mn = I2C1_Rd(1);
    *year = I2C1_Rd(0);
    I2C1_Stop();
}


void Transform_Time(char  *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year) {
    *sec  =  ((*sec & 0x70) >> 4)*10 + (*sec & 0x0F);
    *min  =  ((*min & 0xF0) >> 4)*10 + (*min & 0x0F);
    *hr   =  ((*hr & 0x30) >> 4)*10 + (*hr & 0x0F);
    *week_day =(*week_day & 0x07);
    *day  =  ((*day & 0xF0) >> 4)*10 + (*day & 0x0F);
    *mn   =  ((*mn & 0x10) >> 4)*10 + (*mn & 0x0F);
    *year =  ((*year & 0xF0)>>4)*10+(*year & 0x0F);
}


void Display_Time(char sec, char min, char hr, char week_day, char day, char mn, char year) {

    printf("\r");
    switch(week_day){
        case 1:
            txt = "Sun";
            break;
        case 2:
            txt = "Mon";
            break;
        case 3:
            txt = "Tue";
            break;
        case 4:
            txt = "Wed";
            break;
        case 5:
            txt = "Thu";
            break;
        case 6:
            txt = "Fri";
            break;
        case 7:
            txt = "Sat";
            break;
        default:
            txt = "Inv";
            break;
   }
   printf(txt);

   putch(' ');
   putch((day / 10) + 48);
   putch((day % 10)   + 48);
   putch('-');
   putch((mn / 10) + 48);
   putch((mn % 10) + 48);
   printf("-202");
   putch( year  + 48);

   putch(' ');
   putch((hr / 10)   + 48);
   putch((hr % 10)   + 48);
   putch(':');
   putch((min / 10) + 48);
   putch((min % 10) + 48);
   putch(':');
   putch((sec / 10) + 48);
   putch((sec % 10) + 48);
   if((sec > 59 ) || (min > 59 ) || (hr > 23 ) || (day > 31 ) || (mn > 12 )){
       printf("  * Invalid ! *");
       printf("\r\n  check 1307 RTC connections\r\n");
       printf("  check that supply is 5 Volts, not 3.3 Volts\r\n");
   }
}


void main(void) {

    PPS_Init();
    IO_Init();
    UART_Init();
    LCD_Init();
    LCD_Text("Mon7a 26-09-22  ");
    Interrupt_Init();

    I2C1_Init(100000);
    SPI2_Init();


    printf("\r\nMon7a 26 September 2022\r\n\n");

    while(1){
        linein(linebuff);
        newcmd = getparams(linebuff);
        switch(newcmd){
            case '7':
                cmd7();
                break;

            case 'A':
                cmda();
                break;

            case 'D':
                cmdd();
                break;

            case 'F':
                cmdf();
                break;

            case 'L':
                cmdl();
                break;

            case 'R':
                cmdr();
                break;

            case 'T':
                cmdt();
                break;

            case 'W':
                cmdw();
                break;

            case 'Z':
                cmdz();
                break;

            case '?':
                printf("\r\n");
                printf("?                 List Commands\r\n");
                printf("7                 serial 7-seg test\r\n");
                printf("a dd dd dd        SPI write\r\n");
                printf("d mm hh w dd mm y write Date/time to 1307 RTC\r\n");
                printf("f dd              Fill with dd i2cEEPROM\r\n");
                printf("l                 LCD test\r\n");
                printf("r                 Read i2cEEPROM\r\n");
                printf("t                 read Time from 1307 RTC\r\n");
                printf("w aaa dd          Write i2cEEPROM\r\n");
                printf("z                 set fixed date/time to 1307 RTC\r\n");
                printf("\r\n");
                break;
            default:{
                printf("\r\ncommand not recognised\r\n");
                break;
            }
        }
    }
}


void I2C1_Init(const unsigned long clock){

    SSP1STAT = 0x80;
    SSP1CON1 = 0x28;
    SSP1CON2 = 0x00;
    SSP1ADD = 49;

}



unsigned short I2C1_Start(void){
    BCL1IF_bit = 0;
    SEN1_bit = 1;
    while (SEN1_bit);
    return BCL1IF_bit;
}


void I2C1_Stop(void){
    PEN1_bit = 1;
    while (PEN1_bit);
}


void I2C1_Repeated_Start(void){
    RSEN1_bit = 1;
    while (RSEN1_bit);
}



unsigned short I2C1_Wr(unsigned short data_){
    SSP1BUF = (unsigned char)data_;
    asm ("nop");
    while (R_W1_bit);
    return ACKSTAT1_bit;
}

unsigned char I2C1_Rd(unsigned char ackflag){
    RCEN1_bit = 1;
    ACKDT1_bit = !(ackflag & 0x01);
    while (RCEN1_bit);
    ACKEN1_bit = 1;
    while (ACKEN1_bit);
    return SSP1BUF;
}



void i2cEEPROM_WrSingle(unsigned int wAddr, unsigned char wData) {
  unsigned char hi_addr;

    wAddr &= 0x3ff;
    hi_addr = (wAddr >> 7) & 0x06;
    I2C1_Start();
    I2C1_Wr(0xA0 | hi_addr);
    I2C1_Wr(wAddr);
    I2C1_Wr(wData);
    I2C1_Stop();
    Delay_ms(10);
}


unsigned char i2cEEPROM_RdSingle(unsigned int rAddr) {
  unsigned char result;
  unsigned char hi_addr;

    rAddr &= 0x3ff;
    hi_addr = (rAddr >> 7) & 0x06;
    I2C1_Start();
    I2C1_Wr(0xA0 | hi_addr);
    I2C1_Wr(rAddr);
    I2C1_Repeated_Start();
    I2C1_Wr(0xA1 | hi_addr);
    result = I2C1_Rd(0);
    I2C1_Stop();
    return result;
}


void PrintHex(unsigned char ihex) {
unsigned char hib,lob;

    hib = ihex & 0xF0;
    hib = hib >> 4;
    hib = hib + '0';
    if (hib > '9') hib = hib + 7;
    lob = (ihex & 0x0F) + '0';
    if (lob > '9') lob = lob+7;

    putch(hib);
    putch(lob);
}


void PrintHexSp(unsigned char ihex) {
unsigned char hib,lob;

    hib = ihex & 0xF0;
    hib = hib >> 4;
    hib = hib + '0';
    if (hib > '9') hib = hib + 7;
    lob = (ihex & 0x0F) + '0';
    if (lob > '9') lob = lob + 7;

    putch(hib);
    putch(lob);
    putch(' ');
}


void PrintHexInt(unsigned int ihex) {
    PrintHex((ihex >> 8) & 0xff);
    PrintHex(ihex & 0xff);
}


char getparams(char* tempstring){
  char oldcmd;
  int  n;
  char tempchar;
  char tempchar2;
  unsigned int pointer1 = 0;
  unsigned int pointer2 = 0;

    oldcmd = cmd;
    nparams = 0;
    pointer1 = 0;

    for ( n = 0 ; n < 8 ; n++){

        tempchar=1;
        do {
            tempchar = tempstring[pointer1++];
        } while (tempchar == 0x20);
        pointer1--;


        if ((tempchar != 0) && (nparams < 8)){
            nparams++;
        }

        if (n == 0){
            tempchar=tempstring[pointer1];
            if ((tempchar > 0x60) && (tempchar < 0x7b)) {
                tempchar -= 0x20;
            }
            cmd=tempchar;
        }

        tempchar=1;
        if (nparams != 0){

            pointer2=0;
            do {
                tempchar = tempstring[pointer1++];
                if ((tempchar > 0x60) && (tempchar < 0x7b)) {
                    tempchar -= 0x20;
                }
                param[n][pointer2++] = tempchar;
            } while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20));
            param[n][pointer2-1]=0;
            if((tempchar == 0)||(n == 9)){
                break;
            }
        }
    }


    for (n = 0; n < nparams ; n++){
        tempchar2=1;
        pointer1=0;
        upar[n]=0;
        do {
            tempchar = param[n][pointer1++];

            if ( tempchar != 0 ){
                upar[n] = upar[n] * 0x10;
            }
            tempchar2 = tempchar;
            if ((tempchar < 0x30) || (tempchar > 0x46)) {
                tempchar = 0x00;
            }
            if ((tempchar > 0x39) && (tempchar < 0x41)) {
                tempchar = 0x00;
            }
            if ((tempchar > 0x40) && (tempchar < 0x47)) {
                tempchar -= 0x37;
            }
            if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
                tempchar -= 0x30;
            }
            upar[n] += tempchar;
        } while (tempchar2 != 0);
    }

    if (nparams == 0) {
        cmd = oldcmd;
    }
    return cmd;
}




void linein(char* pstring){
  char inChar = 0;

    while(inChar != '\r'){


        if (RC1IF_bit){
            inChar = chin();
            if(inChar != '\n'){
                putch(inChar);
                if(inChar == '\r'){
                    putch('\n');
                    *pstring ++= '\0';
                }
                else {
                    if (inChar != 0x08 ){
                        *pstring++ = inChar;
                    }
                    if (inChar == 0x08 ){
                        *--pstring = 0x00;
                    }
                }
            }
        }
    }
}


void cmd7(void){
    Chip_Select_Direction = 0;

    max7219_init();

    for (i = 1; i <= 8; i++) {
        Chip_Select = 0;
        SPI_Write(i);
        SPI_Write(seg[8-i]);
        Chip_Select = 1;
    }
}


void cmda(void){

    printf("RD3 CLK, RD2 MISO, RD5 MOSI, RD0 CS#\r\n");
    TRISD2_bit = 1;
    retval1 = upar[1] & 0xff;
    retval2 = upar[2] & 0xff;
    retval3 = upar[3] & 0xff;
    PrintHexSp(retval1);
    PrintHexSp(retval2);
    PrintHexSp(retval3);
    printf("SPI send\r\n");

    Chip_Select  = 0;

    retval1 = SPI_Write(retval1);
    retval2 = SPI_Write(retval2);
    retval3 = SPI_Write(retval3);

    Chip_Select  = 1;
    PrintHexSp(retval1);
    PrintHexSp(retval2);
    PrintHexSp(retval3);
    printf("received\r\n");
}


void cmdd(void){
    if(nparams < 2){
        printf("\r\nneed at least 1 parameter...\r\nd mm hh w dd mm y\r\n");
        printf("minute, hour, weekday 1=Sun, day, month, year 0-9\r\n\n");
    }
    else{
        I2C1_Start();
        I2C1_Wr(0xD0);
        I2C1_Wr(0);
        I2C1_Wr(0x80);
        I2C1_Wr(upar[1] & 0xff);
        if(nparams > 2){
            I2C1_Wr(upar[2] & 0xff);
            if(nparams > 3){
                I2C1_Wr(upar[3] & 0xff);
                if(nparams > 4){
                    I2C1_Wr(upar[4] & 0xff);
                    if(nparams > 5){
                        I2C1_Wr(upar[5] & 0xff);
                        if(nparams > 6){
                            I2C1_Wr(upar[6] & 0xff);
                        }
                    }
                }
            }
        }
        I2C1_Stop();

        I2C1_Start();
        I2C1_Wr(0xD0);
        I2C1_Wr(0);
        I2C1_Wr(0);
        I2C1_Stop();
        printf("new date/time set\r\n\n");
    }
}



void cmdf(void){

    EC_data = upar[1] & 0xff;
    LATC0_bit  = 0;
    printf("\r\nEEPROM Fill");

    if(nparams == 2){
        for(ee_addr = 0; ee_addr < 1024; ee_addr++){
            i2cEEPROM_WrSingle(ee_addr, EC_data);
            if((ee_addr & 0x1f) == 0){
                printf(".");
            }
        }
    }
    else{
        printf("\r\nsyntax error - need...\r\nf dd\r\n");
    }
    LATC0_bit  = 1;
    printf("\r\ndone\r\n");
}


void cmdl(void){
    printf("2x16 LCD test\r\n\n");
    LCD_Init();
    LCD_Clear();
    LCD_Pos(1,1);
    LCD_Text("EasyPIC 7a Mon7a");
    LCD_Pos(2,1);
    LCD_Write(' ');
    LCD_Text("Simple LCD test xxx");


    LCD_Pos(3,1);
    LCD_Text("Line 3 of 4 x 20 LCD");
    LCD_Pos(4,1);
    LCD_Text("Line 4 of 4 x 20 LCD");
}


void cmdr(void){
    LATC0_bit  = 1;
    printf("\r\nEEPROM Contents...");
    ascii_string[16] = 0;
    ascii_string[0] = 0;

    for(EC_adr = 0; EC_adr < 1024; EC_adr++){
        if(! (EC_adr & 0x0f)){
            printf(ascii_string);
            printf("\r\n");
            PrintHexInt(EC_adr);
            printf(" = ");
        }
        else{
            if(! (EC_adr & 0x03)){
                printf("- ");
            }
        }
        EC_tmp = (EC_adr >> 8) & 0x03;
        EC_hdr = 0x50 + EC_tmp;
        EC_data = i2cEEPROM_RdSingle(EC_adr);
        PrintHexSp(EC_data);
        if((EC_data > 31) && (EC_data < 128)){
            ascii_string[EC_adr & 0x0f] = EC_data;
        }
        else{
            ascii_string[EC_adr & 0x0f] = '.';
        }
        Delay_ms(1);
    }
    printf(ascii_string);
    printf("\r\n");
}


void cmdt(void){
    printf("time from 1307 RTC\r\n");
    Read_Time(&sec,&min1,&hr,&week_day,&day,&mn,&year);
    t_sec = sec;
    t_min = min1;
    Transform_Time(&sec,&min1,&hr,&week_day,&day,&mn,&year);
    Display_Time(sec, min1, hr, week_day, day, mn, year);
    printf("\r\n");
}



void cmdw(void){

    EC_adr = upar[1];
    EC_data = upar[2] & 0xff;

    LATC0_bit  = 0;
    printf("\r\nEEPROM Write...");

    Delay_ms(100);

    if(nparams == 3){
        i2cEEPROM_WrSingle(EC_adr, EC_data);
    }
    else{
        printf("syntax error - need...\r\nw aaa dd\r\n");
    }
    LATC0_bit  = 1;
    printf("\r\n");
}


void cmdz(void){
    I2C1_Start();
    I2C1_Wr(0xD0);
    I2C1_Wr(0);
    I2C1_Wr(0x80);
    I2C1_Wr(0x00);
    I2C1_Wr(0x23);
    I2C1_Wr(0x07);
    I2C1_Wr(0x24);
    I2C1_Wr(0x09);
    I2C1_Wr(0x02);
    I2C1_Stop();

    I2C1_Start();
    I2C1_Wr(0xD0);
    I2C1_Wr(0);
    I2C1_Wr(0);
    I2C1_Stop();
    printf("1307 date/time reset\r\n");
}

void max7219_init() {
    Chip_Select = 0;
    SPI_Write(0x09);
    SPI_Write(0x00);
    Chip_Select = 1;

    Chip_Select = 0;
    SPI_Write(0x0A);
    SPI_Write(0x0b);
    Chip_Select = 1;

    Chip_Select = 0;
    SPI_Write(0x0B);
    SPI_Write(0x07);
    Chip_Select = 1;

    Chip_Select = 0;
    SPI_Write(0x0C);
    SPI_Write(0x01);
    Chip_Select = 1;

    Chip_Select = 0;
    SPI_Write(0x00);
    SPI_Write(0xFF);
    Chip_Select = 1;
    Delay_ms(100);
}


void set_luminosity(unsigned char value){
    Chip_Select = 0;
    SPI_Write(0x0A);
    SPI_Write(value);
    Chip_Select = 1;
}
